function SimObject::hasMethod(%this,%name)
{
	return isFunction(%this.getName(),%name) || isFunction(%this.class,%name) || isFunction(%this.getClassName(),%name);
}

function SimObject::call(%this,%func,%a,%b,%c,%d,%e,%f,%g,%h,%i,%j,%k,%l,%m,%n,%o,%p,%q,%r,%s,%t,%u,%v,%w,%x,%y,%z)
{
	if(!%this.hasMethod(%func))
	{
		error("SimObject::call - No method '" @ %func @ "' exists for this object.");
		return;
	}
	for(%it=0;%it<26;%it++)
	{
		%val = "%" @ getsubstr("abcdefghijklmnopqrstuvwxyz",%it,1);
		%val = eval("return" SPC %val @ ";");
		if(%val $= "")
		{
			break;
		}
		%args = %args $= "" ? "\"" @ expandEscape(%val) @ "\"" : %args @ ",\"" @ expandEscape(%val) @ "\"";
	}
	return eval("return " @ %this.getID() @ "." @ %func @ "(" @ %args @ ");");
}

function colorGradient( %nn, %cr1, %cg1, %cb1, %cr2, %cg2, %cb2 )
{
	if ( !strLen( %cb1 ) )
	{
		%cr2 = getWord( %cg1, 0 );
		%cg2 = getWord( %cg1, 1 );
		%cb2 = getWord( %cg1, 2 );

		%cg1 = getWord( %cr1, 1 );
		%cb1 = getWord( %cr1, 2 );
		%cr1 = getWord( %cr1, 0 );
	}
	
	%cr = %cr1 - ( %cr1 - %cr2 ) * %nn;
	%cg = %cg1 - ( %cg1 - %cg2 ) * %nn;
	%cb = %cb1 - ( %cb1 - %cb2 ) * %nn;

	return mFloatLength( %cr, 0 ) SPC mFloatLength( %cg, 0 ) SPC mFloatLength( %cb, 0 );
}

function rgbToHex( %rgb )
{
	return s255ToHex( getWord( %rgb, 0 ) ) @ s255ToHex( getWord( %rgb, 1 ) ) @ s255ToHex( getWord( %rgb, 2 ) );
}

function s255ToHex( %d )
{
	%r = mFloor( %d / 16 );
	%d -= %r * 16;

	return hidToChr( %r ) @ hidToChr( %d );
}

function hidToChr(%n)
{
	return getSubStr( "0123456789ABCDEF" , %n, 1 );
}